import time
from sys import stdout


class PTPBar:
    def __init__(self, total, desc="进度",block1='█',block2=' '):
        self.total = total
        self.desc = desc
        self.current = 0
        self.block1 = block1
        self.block2 = block2

    def update(self, step=1):
        self.current += step
        percent = (self.current / self.total) * 100
        bar_length = 30  # 进度条长度
        block = int(bar_length * self.current / self.total)
        progress = self.block1 * block + self.block2 * (bar_length - block)
        stdout.write(f'\r{self.desc}: |{progress}| {percent:.2f}%')
        #绘制进度条
        stdout.flush()

    def finish(self):
        self.current = self.total
        self.update(0)  # 更新到100%


if __name__ == "__main__":
    progress_bar = PTPBar(10000, desc="downloading")
    #论Python重复执行1000000要多久

    for _ in range(10000):
        #1000000次循环
        progress_bar.update()

    progress_bar.finish()
